#ifndef _BOOTPACK_H_
#define _BOOTPACK_H_
/**************************************************

	NegitoroVXewb_[

	ύXڍ
	3/18 V[g̃tOeɕς܂ by is2os
	3/31 window.cmenu.cƂɕ by is2os
	4/1 L[̒leɂ by is2os
	4/6 MOUSE_INFO\̂ǉ by is2os
	4/8 API߂Ɋ̍\̂ǉ by is2os
	4/10 }EXAPIp̃O[oϐǉ by is2os
	
**************************************************/
#define	ADDRESS_FOUND_APM	0x0cc0	
#define ADDRESS_DEVICE_LIST	0x0cc2

#define SHEET_BACK_FLAGS	0x1
#define SHEET_STARTMENU_FLAGS 0x2
#define SHEET_NEGIMAN_FLAGS	0x5
#define SHEET_SHTDWN_FLAGS	0x8
#define SHEET_APP_FLAGS		0x10
#define SHEET_CONSOLE_FLAGS	0x20
#define SHEET_LAUNCH_FLAGS 0x40

/* asmhead.nas */
struct BOOTINFO { /* 0x0ff0-0x0ff8 */
	char cyls; /* u[gZN^͂ǂ܂ŃfBXNǂ񂾂̂ */
	char leds; /* u[g̃L[{[hLED̏ */
	char vmode; /* rfI[h  rbgJ[ */
	char reserve;
	short scrnx, scrny; /* ʉ𑜓x */
	char *vram;
};
#define ADR_BOOTINFO	0x00000ff0
#define ADR_DISKIMG		0x00100000

/* naskfunc32.nas */
void io_nop(void);
void io_hlt(void);
void io_cli(void);
void io_sti(void);
void io_stihlt(void);
int io_in8(int port);
void io_out8(int port, int data);
int io_load_eflags(void);
void io_store_eflags(int eflags);
void load_gdtr(int limit, int addr);
void load_idtr(int limit, int addr);
int load_cr0(void);
void store_cr0(int cr0);
void load_tr(int tr);
void asm_inthandler0c(void);
void asm_inthandler0d(void);
void asm_inthandler20(void);
void asm_inthandler21(void);
void asm_inthandler2c(void);
unsigned int memtest_sub(unsigned int start, unsigned int end);
void farjmp(int eip, int cs);
void farcall(int eip, int cs);
void asm_hrb_api(void);
void start_app(int eip, int cs, int esp, int ds, int *tss_esp0);
void asm_end_app(void);
void change_system16(void);
void stop_system(void);

/* naskfunc16.nas */
void apm_shutdown(void);
void system_reboot(void);

/* fifo.c */
struct FIFO32 {
	int *buf;
	int p, q, size, free, flags;
	struct TASK *task;
};
void fifo32_init(struct FIFO32 *fifo, int size, int *buf, struct TASK *task);
int fifo32_put(struct FIFO32 *fifo, int data);
int fifo32_get(struct FIFO32 *fifo);
int fifo32_status(struct FIFO32 *fifo);

/* graphic.c */
void init_palette(void);
void set_palette(int start, int end, unsigned char *rgb);
void boxfill8(unsigned char *vram, int xsize, unsigned char c, int x0, int y0, int x1, int y1);
void start_screen(char *vram, struct BOOTINFO *binfo, int *fat, char *logoname);
void init_screen8(char *vram, struct BOOTINFO *binfo, int *fat, char *wallname);
void putfont8(char *vram, int xsize, int x, int y, char c, char *font);
void putfonts8_asc(char *vram, int xsize, int x, int y, char c, unsigned char *s);
void init_mouse_cursor8(char *mouse, char bc);
void putblock8_8(char *vram, int vxsize, int pxsize,
	int pysize, int px0, int py0, char *buf, int bxsize);
#define COL8_000000		0
#define COL8_FF0000		1
#define COL8_00FF00		2
#define COL8_FFFF00		3
#define COL8_0000FF		4
#define COL8_FF00FF		5
#define COL8_00FFFF		6
#define COL8_FFFFFF		7
#define COL8_C6C6C6		8
#define COL8_840000		9
#define COL8_008400		10
#define COL8_848400		11
#define COL8_000084		12
#define COL8_840084		13
#define COL8_008484		14
#define COL8_848484		15
struct SHEET {
	unsigned char *buf;
	int bxsize, bysize, vx0, vy0, col_inv, height, flags;
	struct SHTCTL *ctl;
	struct TASK *task;
	char *window_name;
};
int set_system32icon(struct SHTCTL *shtctl, char *icon_name);
int drawicon_sheet(struct SHTCTL *shtctl, char *draw_to, int pos_x, int pos_y, 
							char *icon_name, char *icon_file, int *fat, int color);

/* dsctbl.c */
struct SEGMENT_DESCRIPTOR {
	short limit_low, base_low;
	char base_mid, access_right;
	char limit_high, base_high;
};
struct GATE_DESCRIPTOR {
	short offset_low, selector;
	char dw_count, access_right;
	short offset_high;
};
void init_gdtidt(void);
void set_segmdesc(struct SEGMENT_DESCRIPTOR *sd, unsigned int limit, int base, int ar);
void set_gatedesc(struct GATE_DESCRIPTOR *gd, int offset, int selector, int ar);
#define ADR_IDT			0x0026f800
#define LIMIT_IDT		0x000007ff
#define ADR_GDT			0x00270000
#define LIMIT_GDT		0x0000ffff
#define ADR_BOTPAK		0x00280000
#define LIMIT_BOTPAK	0x0007ffff
#define AR_DATA32_RW	0x4092
#define AR_CODE32_ER	0x409a
#define AR_LDT			0x0082
#define AR_TSS32		0x0089
#define AR_INTGATE32	0x008e

/* int.c */
void init_pic(void);
#define PIC0_ICW1		0x0020
#define PIC0_OCW2		0x0020
#define PIC0_IMR		0x0021
#define PIC0_ICW2		0x0021
#define PIC0_ICW3		0x0021
#define PIC0_ICW4		0x0021
#define PIC1_ICW1		0x00a0
#define PIC1_OCW2		0x00a0
#define PIC1_IMR		0x00a1
#define PIC1_ICW2		0x00a1
#define PIC1_ICW3		0x00a1
#define PIC1_ICW4		0x00a1
void put_debugmessage32(char *string, int current);

/* keyboard.c */
#define KEYCODE_F1		0x3b
#define KEYCODE_F2		0x3c
#define KEYCODE_F3		0x3d
#define KEYCODE_F4		0
#define KEYCODE_F5		0
#define KEYCODE_F6		0
#define KEYCODE_F7		0x41
#define KEYCODE_F8		0
#define KEYCODE_F9		0
#define KEYCODE_F10		0x44
#define KEYCODE_F11		0x57
#define KEYCODE_F12		0x58
#define KBDATA_SUCCESS	0xfa
#define KBDATA_FAILES	0xfe
void inthandler21(int *esp);
void wait_KBC_sendready(void);
void init_keyboard(struct FIFO32 *fifo, int data0);
#define PORT_KEYDAT		0x0060
#define PORT_KEYCMD		0x0064

/* mouse.c */
struct MOUSE_DEC {
	unsigned char buf[3], phase;
	int x, y, btn;
};
void inthandler2c(int *esp);
void enable_mouse(struct FIFO32 *fifo, int data0, struct MOUSE_DEC *mdec);
int mouse_decode(struct MOUSE_DEC *mdec, unsigned char dat);
struct MOUSE_INFO {
	int x, y, button, state;
};
extern struct MOUSE_INFO minfo;

/* memory.c */
#define MEMMAN_FREES		4090	/* Ŗ32KB */
#define MEMMAN_ADDR			0x003c0000
struct FREEINFO {	/*  */
	unsigned int addr, size;
};
struct MEMMAN {		/* Ǘ */
	int frees, maxfrees, lostsize, losts;
	struct FREEINFO free[MEMMAN_FREES];
};
unsigned int memtest(unsigned int start, unsigned int end);
void memman_init(struct MEMMAN *man);
unsigned int memman_total(struct MEMMAN *man);
unsigned int memman_alloc(struct MEMMAN *man, unsigned int size);
int memman_free(struct MEMMAN *man, unsigned int addr, unsigned int size);
unsigned int memman_alloc_4k(struct MEMMAN *man, unsigned int size);
int memman_free_4k(struct MEMMAN *man, unsigned int addr, unsigned int size);

/* sheet.c */
#define MAX_SHEETS		256
struct SHTCTL {
	unsigned char *vram, *map;
	int xsize, ysize, top;
	struct SHEET *sheets[MAX_SHEETS];
	struct SHEET sheets0[MAX_SHEETS];
	char *icon_default;
};
struct SHTCTL *shtctl_init(struct MEMMAN *memman, unsigned char *vram, int xsize, int ysize);
struct SHEET *sheet_alloc(struct SHTCTL *ctl);
void sheet_setbuf(struct SHEET *sht, unsigned char *buf, int xsize, int ysize, int col_inv);
void sheet_updown(struct SHEET *sht, int height);
void sheet_refresh(struct SHEET *sht, int bx0, int by0, int bx1, int by1);
void sheet_slide(struct SHEET *sht, int vx0, int vy0);
void sheet_free(struct SHEET *sht);

/* timer.c */
#define MAX_TIMER		500
struct TIMER {
	struct TIMER *next;
	unsigned int timeout;
	char flags, flags2;
	struct FIFO32 *fifo;
	int data;
};
struct TIMERCTL {
	unsigned int count, next;
	struct TIMER *t0;
	struct TIMER timers0[MAX_TIMER];
};
extern struct TIMERCTL timerctl;
void init_pit(void);
struct TIMER *timer_alloc(void);
void timer_free(struct TIMER *timer);
void timer_init(struct TIMER *timer, struct FIFO32 *fifo, int data);
void timer_settime(struct TIMER *timer, unsigned int timeout);
void inthandler20(int *esp);
int timer_cancel(struct TIMER *timer);
void timer_cancelall(struct FIFO32 *fifo);

/* mtask.c */
#define MAX_TASKS		1000	/* ő^XN */
#define TASK_GDT0		3		/* TSSGDT̉Ԃ犄蓖Ă̂ */
#define MAX_TASKS_LV	100
#define MAX_TASKLEVELS	10
struct TSS32 {
	int backlink, esp0, ss0, esp1, ss1, esp2, ss2, cr3;
	int eip, eflags, eax, ecx, edx, ebx, esp, ebp, esi, edi;
	int es, cs, ss, ds, fs, gs;
	int ldtr, iomap;
};
struct TASK {
	int sel, flags; /* selGDT̔ԍ̂ */
	int level, priority;
	struct FIFO32 fifo;
	struct TSS32 tss;
	struct SEGMENT_DESCRIPTOR ldt[2];
	struct CONSOLE *cons;
	int ds_base, cons_stack;
	struct FILEHANDLE *fhandle;
	int *fat;
	char *cmdline;
	unsigned char langmode, langbyte1;
	char *tasknm;
};
struct TASKLEVEL {
	int running; /* 삵Ă^XN̐ */
	int now; /* ݓ삵Ă^XNǂꂾ悤ɂ邽߂̕ϐ */
	struct TASK *tasks[MAX_TASKS_LV];
};
struct TASKCTL {
	int now_lv; /* ݓ쒆̃x */
	char lv_change; /* ^XNXCb`̂ƂɁAxςقǂ */
	struct TASKLEVEL level[MAX_TASKLEVELS];
	struct TASK tasks0[MAX_TASKS];
	char debug_mode;	/* fobO[hON/OFF */
};
extern struct TASKCTL *taskctl;
extern struct TIMER *task_timer;
struct TASK *task_now(void);
struct TASK *task_init(struct MEMMAN *memman);
struct TASK *task_alloc(void);
void task_run(struct TASK *task, int level, int priority, char *tskname);
void task_switch(void);
void task_sleep(struct TASK *task);

/* window.c */
void make_window8(unsigned char *buf, int xsize, int ysize, char *title, char act);
void putfonts8_asc_sht(struct SHEET *sht, int x, int y, int c, int b, char *s, int l);
void make_textbox8(struct SHEET *sht, int x0, int y0, int sx, int sy, int c);
void make_pushbutton8(struct SHEET *sht, int x0, int y0, int sx, int sy, char *caption);
void make_wtitle8(unsigned char *buf, int xsize, char *title, char act);
void change_wtitle8(struct SHEET *sht, char act);

/* console.c */
struct CONSOLE {
	struct SHEET *sht;
	int cur_x, cur_y, cur_c;
	struct TIMER *timer;
};
struct FILEHANDLE {
	char *buf;
	int size;
	int pos;
};
void console_task(struct SHEET *sheet, int memtotal);
void cons_putchar(struct CONSOLE *cons, int chr, char move);
void cons_newline(struct CONSOLE *cons);
void cons_putstr0(struct CONSOLE *cons, char *s);
void cons_putstr1(struct CONSOLE *cons, char *s, int l);
void cons_runcmd(char *cmdline, struct CONSOLE *cons, int *fat, int memtotal);
int *inthandler0d(int *esp);
int *inthandler0c(int *esp);
void hrb_api_linewin(struct SHEET *sht, int x0, int y0, int x1, int y1, int col);

/* command.c */
void cmd_mem(struct CONSOLE *cons, int memtotal);
void cmd_cls(struct CONSOLE *cons);
void cmd_dir(struct CONSOLE *cons, char *cmdline, int memtotal);
void cmd_exit(struct CONSOLE *cons, int *fat);
void cmd_start(struct CONSOLE *cons, char *cmdline, int memtotal);
void cmd_ncst(struct CONSOLE *cons, char *cmdline, int memtotal);
void cmd_langmode(struct CONSOLE *cons, char *cmdline);
void cmd_debug(struct CONSOLE *cons);
int cmd_app(struct CONSOLE *cons, int *fat, char *cmdline);
void cmd_help(struct CONSOLE *cons);
void cmd_create(struct CONSOLE *cons, char *cmdline);

/* file.c */
struct FILEINFO {
	unsigned char name[8], ext[3], type;
	char reserve[10];
	unsigned short time, date, clustno;
	unsigned int size;
};
void file_readfat(int *fat, unsigned char *img);
void file_loadfile(int clustno, int size, char *buf, int *fat, char *img);
struct FILEINFO *file_search(char *name, struct FILEINFO *finfo, int max);
char *file_loadfile2(int clustno, int *psize, int *fat);
unsigned short file_getfat(int *fat);
struct FILEINFO *file_create(int *fat, char *filename);
void file_setname(struct FILEINFO *finfo, char *name);
void file_fatwrite(int *fat);

/* tek.c */
int tek_getsize(unsigned char *p);
int tek_decomp(unsigned char *p, char *q, int size);

/* bootpack.c */
/* L[{[h̓ꕶ */
#define LEFT_SHIFT_ON	0x2a
#define LEFT_SHIFT_OFF	0xaa
#define RIGHT_SHIFT_ON	0x36
#define RIGHT_SHIFT_OFF	0xb6
#define CTRL_ON			0x1d
#define CTRL_OFF		0x9d
#define ALT_ON			0x38
#define ALT_OFF			0xb8
#define LANGCHG_ON		0x29
#define CAPSLOCK_ON		0x3a
#define NUMLOCK_ON		0x45
#define SCRLLOCK_ON		0x46
/* FIFOf[^ʐl */
#define ADD_KEYDATA		256
#define ADD_MOUSEDATA	512
struct TASK *open_constask(struct SHEET *sht, unsigned int memtotal);
struct SHEET *open_console(struct SHTCTL *shtctl, unsigned int memtotal);
extern int mouse_x, mouse_y;

/* api.c */
struct DISPINFO {
	int  display_x, display_y;
};
int *hrb_api(int edi, int esi, int ebp, int esp, int ebx, int edx, int ecx, int eax);

/* clock.c */
struct SYSTIME {
	int year_high, year_low;
	int month, day;
	int hour, minute, second;
};
int read_cmos(unsigned char *a);
struct TASK *open_clocktask(struct SHEET *sht, unsigned char *buf);
void close_clocktask(struct TASK *task);
void clock_task(struct SHEET *sht, unsigned char *buf);

/* negiman.c */
struct SHEET *open_taskman(struct SHTCTL *shtctl, unsigned int memtotal);
void close_taskman(struct SHEET *sht, struct TASK *task, unsigned long mem);
void taskman_task(struct SHEET *sht);

/* shutdown.c */
void shutdown_task(unsigned char *back_buffer, struct SHEET *back_sheet,
						struct TASK *sys_task, struct TASK *clock_task);
struct SHEET *open_shutdown(struct SHTCTL *shtctl, unsigned char *back_buffer,
							struct SHEET *back_sheet, struct TASK *sys_task, 
							struct TASK *clock_task);
void close_shutdown(struct SHEET *sht, struct TASK *task, unsigned long size);

/* menu.c */
struct SHEET *open_startmenu_task(struct SHTCTL *shtctl);
void close_startmenu_task(struct TASK *task, struct SHEET *sht, unsigned long mem); 
void make_startmenu(struct SHEET *sht, char *caption);
void startmenu_task(void);
void application_shellexec(char *appname, unsigned int memtotal);

/* lunch.c */
struct SHEET *open_applaunch(struct SHTCTL *shtctl, int memtotal);
void close_applaunch(struct TASK *task, struct SHEET *sht, unsigned long mem);
void applaunch_task(struct SHEET *sht, int apps, int memtotal);

#endif
